#ifndef SIMPOPTREE_H_
#define SIMPOPTREE_H_

typedef int * haplotype;

typedef struct simnodetype {
    int *haplotype;
    int location;
    double time;
    struct simnodetype *descendent1;
    struct simnodetype *descendent2;
} simnode;

typedef struct popnodetype {
    int location;
    int lines;
    struct popnodetype *left,*right,*up;
    simnode *sample;
    double time;
    double r;
    double relpopsize;
} popnode;

typedef struct poptreetype {
    popnode *populations;
    popnode *root;
    simnode *simroot;
    int npops;
} poptree;
poptree simulate_poptree(int *n,int migmodel, int model, int npops, double *pars
			 , double *proportions);
void destroy_poptree(poptree *any);

#endif

